﻿/*
 * -------------------------------------------------------------------------------
 * 功能描述：
 * 
 * 创建人：　	JunHan(俊涵)
 * 创建日期：	2013/12/13 22:53:45
 * 创建说明：	
 * 
 * 修改人：　	
 * 修改日期：	
 * 修改说明：	
 *    
 * -------------------------------------------------------------------------------
 */
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WeDiscuss.Plugin.Framework
{
    public class WidgetContainer
    {
        public class ContainerWidget
        {
            public int Position { get; set; }
            public string WidgetId { get; set; }
            public object WidgetOptions { get; set; }
        }
        public class WidgetDetails
        {
            public WidgetDetails(string widgetId, object widgetOptions = null)
            {
                WidgetId = widgetId;
                WidgetOptions = widgetOptions;
            }
            public string WidgetId { get; set; }
            public object WidgetOptions { get; set; }
        }

        public WidgetContainer(string id, params WidgetDetails[] widgets)
        {
            Id = id;
            Widgets = new List<ContainerWidget>();

            int pos = 0;
            foreach (WidgetDetails widge in widgets)
                Widgets.Add(new ContainerWidget() { Position = pos++, WidgetId = widge.WidgetId, WidgetOptions = widge.WidgetOptions });
        }

        public string Id { get; private set; }
        public List<ContainerWidget> Widgets { get; private set; }

        public void AddWidget(string widgetId, int position = -1)
        {
            Widgets.Add(new ContainerWidget() { Position = position, WidgetId = widgetId });
        }
    }
}
