﻿using System;
using System.Collections.Generic;
using System.ComponentModel.Composition;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WeDiscuss.Plugin.Framework;

namespace WeDiscuss.Plugin.Admin
{
    [Export(typeof(IMvcPlugin))]
    [MvcPluginMetadata("NewsPlugin", null, "Demo App Site News", "")]
    class NewsPlugin : AppPlugin
    {
        public override void SetupExtensions(IMvcPluginApplication app)
        {
            base.SetupExtensions(app);
            DefineMenuItem(new PluginMenu { MenuText = "News", MenuUrl = "/News", MenuType = 1, MenuOrder = 0 });
        }
    }
}
